explain_setpgrp_or_die(3)

NAME
explain_setpgrp_or_die - set process group and report errors

SYNOPSIS
#include <libexplain/setpgrp.h>

void explain_setpgrp_or_die(pid_t pid, pid_t pgid);
int explain_setpgrp_on_error(pid_t pid, pid_t pgid);

DESCRIPTION
The explain_setpgrp_or_die function is used to call the setpgrp(2) system call. On failure an explanation will be printed to stderr, obtained from the explain_setpgrp(3) function, and then the process terminates by calling exit(EXIT_FAILURE).

The explain_setpgrp_on_error function is used to call the setpgrp(2) system call. On failure an explanation will be printed to stderr, obtained from the explain_setpgrp(3) function, but still returns to the caller.

pid The pid, exactly as to be passed to the setpgrp(2) system call.

pgid
    The pgid, exactly as to be passed to the setpgrp(2) system call.

Note: the setpgrp(2) function has two implementations. The System V version has no arguments, while the BSD version has two arguments. For simplicity of implementation, the argument list seen here includes the pid and pgid arguments.

The System V getpgid() semantics can be obtained by calling setpgrp(0, 0) on systems with the BSD version, and this is the API for libexplain, even on systems that do not use the BSD API.

RETURN VALUE
The explain_setpgrp_or_die function only returns on success, see setpgrp(2) for more information. On failure, prints an explanation and exits, it does not return.

The explain_setpgrp_on_error function always returns the value return by the wrapped setpgrp(2) system call.

EXAMPLE
The explain_setpgrp_or_die function is intended to be used in a fashion similar to the following example:
    explain_setpgrp_or_die(pid, pgid);

SEE ALSO

setpgrp(2)
    set process group

explain_setpgrp(3)
    explain setpgrp(2) errors

exit(2)
    terminate the calling process

COPYRIGHT
libexplain version
Copyright (C) 2011 Peter Miller